Summary:    HP Linux Imaging and Printing Project
Name:       hplip
Version:    3.22.10
Release:    6%{?dist}
License:    GPLv2+ and MIT and BSD and IJG and GPLv2+ with exceptions and ISC
Url:        https://developers.hp.com/hp-linux-imaging-and-printing
Source0:    http://downloads.sourceforge.net/sourceforge/hplip/hplip-%{version}.tar.gz
Source1:    hpcups-update-ppds.sh
Source2:    copy-deviceids.py
Source3:    %{name}.appdata.xml
Source4:    hp-laserjet_cp_1025nw.ppd.gz
Source5:    hp-laserjet_professional_p_1102w.ppd.gz
Source6:    hp-plugin.in

Patch3000:  hplip-pstotiff-is-rubbish.patch
Patch3001:  hplip-strstr-const.patch
Patch3002:  hplip-ui-optional.patch
Patch3003:  hplip-no-asm.patch
Patch3004:  hplip-deviceIDs-drv.patch
Patch3005:  hplip-udev-rules.patch
Patch3006:  hplip-retry-open.patch
Patch3007:  hplip-snmp-quirks.patch
Patch3008:  hplip-hpijs-marker-supply.patch
Patch3009:  hplip-clear-old-state-reasons.patch
Patch3010:  hplip-hpcups-sigpipe.patch
Patch3011:  hplip-logdir.patch
Patch3012:  hplip-bad-low-ink-warning.patch
Patch3013:  hplip-deviceIDs-ppd.patch
Patch3014:  hplip-ppd-ImageableArea.patch
Patch3015:  hplip-scan-tmp.patch
Patch3016:  hplip-log-stderr.patch
Patch3017:  hplip-avahi-parsing.patch
Patch3018:  hplip-dj990c-margin.patch
Patch3019:  hplip-strncpy.patch
Patch3020:  hplip-no-write-bytecode.patch
Patch3021:  hplip-silence-ioerror.patch
Patch3022:  hplip-sourceoption.patch
Patch3023:  hplip-noernie.patch
Patch3024:  hplip-appdata.patch
Patch3025:  hplip-check-cups.patch
Patch3026:  hplip-typo.patch
Patch3027:  hplip-use-binary-str.patch
Patch3028:  hplip-error-print.patch
Patch3029:  hplip-hpfax-importerror-print.patch
Patch3030:  hplip-wifisetup.patch
Patch3031:  hplip-keyserver.patch
Patch3032:  0026-Call-QMessageBox-constructors-of-PyQT5-with-the-corr.patch
Patch3033:  0025-Remove-all-ImageProcessor-functionality-which-is-clo.patch
Patch3034:  0027-Fixed-incomplete-removal-of-hp-toolbox-features-whic.patch
Patch3935:  hplip-add-ppd-crash.patch
Patch3036:  hplip-missing-links.patch
Patch3037:  hplip-hplj-3052.patch
Patch3038:  hplip-hpmud-string-parse.patch
Patch3039:  hplip-m278-m281-needs-plugin.patch
Patch3040:  hplip-hpcups-crash.patch
Patch3041:  hplip-covscan.patch
Patch3042:  hplip-logging-segfault.patch
Patch3043:  hplip-systray-blockerror.patch
Patch3044:  hplip-missing-drivers.patch
Patch3045:  hplip-model-mismatch.patch
Patch3046:  hplip-unicodeerror.patch
Patch3047:  hplip-fix-Wreturn-type-warning.patch
Patch3048:  hplip-configure-python.patch
Patch3049:  hplip-dialog-infinite-loop.patch
Patch3050:  hplip-find-driver.patch
Patch3051:  hplip-clean-ldl.patch
Patch3052:  hplip-revert-plugins.patch
Patch3053:  hplip-check-userperms.patch
Patch3054:  hplip-hpsetup-noscanjets.patch
Patch3055:  hplip-hpfirmware-timeout.patch
Patch3056:  hplip-gpgdir-perms.patch
Patch3057:  hplip-plugin-udevissues.patch
Patch3058:  hplip-no-libhpmud-libm-warnings.patch
Patch3059:  hplip-snprintf-format.patch
Patch3060:  hplip-plugin-script.patch
Patch3061:  hplip-pserror-c99.patch
Patch3062:  hplip-scan-orblite-c99.patch
Patch3064:  hplip-pcardext-disable.patch
Patch3065:  hplip-sclpml-strcasestr.patch

BuildRequires: autoconf automake gcc gcc-c++ libtool make
BuildRequires: cups cups-devel libjpeg-devel libusb1-devel net-snmp-devel openssl-devel
BuildRequires: pkgconfig(avahi-client) pkgconfig(avahi-core) pkgconfig(dbus-1)
BuildRequires: python3-cups python3-devel python3-setuptools sane-backends-devel systemd
Requires:      cups gawk python3-dbus systemd tar usbutils wget %{_bindir}/gpg
Requires:      %{name}-libs = %{version}-%{release}
Requires(post):coreutils
Recommends:    avahi-tools
Recommends:    libsane-hpaio = %{version}-%{release}

%description
The Hewlett-Packard Linux Imaging and Printing Project provides
drivers for HP printers and multi-function peripherals.

%package common
Summary: Files needed by the HPLIP printer and scanner drivers
License: GPLv2+

%description common
Files needed by the HPLIP printer and scanner drivers.

%package libs
Summary: HPLIP libraries
License: GPLv2+ and MIT
Requires: %{name}-common = %{version}-%{release}
Requires: python3

%description libs
Libraries needed by HPLIP.

%package -n libsane-hpaio
Summary: SANE driver for scanners in HP's multi-function devices
License: GPLv2+
Requires: sane-backends
Requires: %{name}-libs = %{version}-%{release}

%description -n libsane-hpaio
SANE driver for scanners in HP's multi-function devices (from HPOJ).

%prep
%setup -q
rm prnt/hpcups/ErnieFilter.{cpp,h} prnt/hpijs/ernieplatform.h
%autopatch -p1 -m 3000 -M 3004

chmod +x %{SOURCE2}
mv prnt/drv/hpijs.drv.in prnt/drv/hpijs.drv.in.deviceIDs-drv-hpijs
%{SOURCE2} prnt/drv/hpcups.drv.in prnt/drv/hpijs.drv.in.deviceIDs-drv-hpijs > prnt/drv/hpijs.drv.in
%autopatch -p1 -m 3005 -M 3012

for ppd_file in $(grep '^diff' %{PATCH3013} | cut -d " " -f 4); do
  gunzip ${ppd_file#*/}.gz
done
%patch3013 -p1 -b .deviceIDs-ppd
for ppd_file in $(grep '^diff' %{PATCH3013} | cut -d " " -f 4); do
  gzip -n ${ppd_file#*/}
done

for ppd_file in $(grep '^diff' %{PATCH3014} | cut -d " " -f 4); do
  gunzip ${ppd_file#*/}.gz
done
%patch3014 -p1 -b .ImageableArea
for ppd_file in $(grep '^diff' %{PATCH3014} | cut -d " " -f 4); do
  gzip -n ${ppd_file#*/}
done

%autopatch -p1 -m 3015 -M 3033

rm prnt/hpcups/libImageProcessor-x86*
%autopatch -p1 -m 3034 -M 3065

sed -i.duplex-constraints -e 's,\(UIConstraints.* \*Duplex\),//\1,' prnt/drv/hpcups.drv.in
find -name '*.py' -print0 | xargs -0 sed -i.env-python -e 's,^#!/usr/bin/env python,#!%{__python3},'
sed -i.env-python -e 's,^#!/usr/bin/env python,#!%{__python3},' prnt/filters/hpps fax/filters/pstotiff
rm locatedriver

cp -p %{SOURCE4} %{SOURCE5} ppd/hpcups
cp -p %{SOURCE6} .


%build
sed -i 's|^AM_INIT_AUTOMAKE|AM_INIT_AUTOMAKE([foreign])|g' configure.in
autoreconf -fiv
%configure \
        --enable-fax-build \
        --enable-foomatic-drv-install \
        --enable-gui-build \
        --enable-hpcups-install \
        --enable-hpijs-install \
        --enable-pp-build \
        --enable-qt5 \
        --enable-scan-build \
        --disable-foomatic-rip-hplip-install \
        --disable-imageProcessor-build \
        --disable-policykit \
        --disable-qt4 \
        --with-mimedir=%{_datadir}/cups/mime PYTHON=%{__python3}

%make_build


%install
mkdir -p %{buildroot}%{_bindir}
%make_install PYTHON=%{__python3}
mkdir -p %{buildroot}/run/hplip
mkdir -p %{buildroot}%{_sharedstatedir}/hp
mkdir -p %{buildroot}%{_tmpfilesdir}

cat > %{buildroot}%{_tmpfilesdir}/hplip.conf <<EOF
# See tmpfiles.d(5) for details

d /run/hplip 0775 root lp -
EOF

rm -rf  %{buildroot}%{_sysconfdir}/sane.d \
        %{buildroot}%{_docdir} \
        %{buildroot}%{_datadir}/hal/fdi \
        %{buildroot}%{_datadir}/hplip/pkservice.py \
        %{buildroot}%{_bindir}/hp-pkservice
rm -rf  %{buildroot}%{_datadir}/hplip/locatedriver* \
        %{buildroot}%{_datadir}/hplip/dat2drv*
rm -f   %{buildroot}%{_bindir}/hp-logcapture \
        %{buildroot}%{_bindir}/hp-doctor \
        %{buildroot}%{_bindir}/hp-pqdiag \
        %{buildroot}%{_datadir}/hplip/logcapture.py \
        %{buildroot}%{_datadir}/hplip/doctor.py \
        %{buildroot}%{_datadir}/hplip/pqdiag.py
rm -f   %{buildroot}%{_bindir}/foomatic-rip \
        %{buildroot}%{_libdir}/cups/filter/foomatic-rip \
        %{buildroot}%{_libdir}/*.la \
        %{buildroot}%{python3_sitearch}/*.la \
        %{buildroot}%{_libdir}/libhpip.so \
        %{buildroot}%{_libdir}/libhpmud.so \
        %{buildroot}%{_libdir}/libhpipp.so \
        %{buildroot}%{_libdir}/libhpdiscovery.so \
        %{buildroot}%{_libdir}/sane/*.la \
        %{buildroot}%{_datadir}/cups/model/foomatic-ppds \
        %{buildroot}%{_datadir}/applications/hplip.desktop \
        %{buildroot}%{_datadir}/ppd/HP/*.ppd
rm -f %{buildroot}%{_datadir}/hplip/hpaio.desc
rm -rf %{buildroot}%{_datadir}/hplip/install.* \
       %{buildroot}%{_datadir}/hplip/uninstall.* \
       %{buildroot}%{_bindir}/hp-uninstall \
       %{buildroot}%{_datadir}/hplip/upgrade.* \
       %{buildroot}%{_bindir}/hp-upgrade \
       %{buildroot}%{_datadir}/hplip/hplip-install
rm -f %{buildroot}%{_datadir}/hplip/hpijs.drv.in.template
rm -f %{buildroot}%{_datadir}/cups/mime/pstotiff.types \
      %{buildroot}%{_datadir}/hplip/fax/pstotiff*
rm -f %{buildroot}%{_datadir}/hplip/hplip-install
rm -f %{buildroot}%{_unitdir}/hplip-printer@.service
rm -f %{buildroot}%{_datadir}/ipp-usb/quirks/HPLIP.conf
rm -rf %{buildroot}%{_bindir}/hp-unload \
       %{buildroot}%{_datadir}/%{name}/pcard
rm -f %{buildroot}%{_sysconfdir}/xdg/autostart/hplip-systray.desktop
rm -rf %{buildroot}%{_bindir}/hp-check \
       %{buildroot}%{_bindir}/hp-devicesettings \
       %{buildroot}%{_bindir}/hp-diagnose_plugin \
       %{buildroot}%{_bindir}/hp-faxsetup \
       %{buildroot}%{_bindir}/hp-linefeedcal \
       %{buildroot}%{_bindir}/hp-makecopies \
       %{buildroot}%{_bindir}/hp-print \
       %{buildroot}%{_bindir}/hp-printsettings \
       %{buildroot}%{_bindir}/hp-systray \
       %{buildroot}%{_bindir}/hp-scan \
       %{buildroot}%{_bindir}/hp-toolbox \
       %{buildroot}%{_bindir}/hp-uiscan \
       %{buildroot}%{_bindir}/hp-wificonfig \
       %{buildroot}%{_datadir}/applications/*.desktop \
       %{buildroot}%{_datadir}/metainfo/hplip.appdata.xml \
       %{buildroot}%{_datadir}/icons/hicolor/*/apps/* \
       %{buildroot}%{_datadir}/hplip/base/imageprocessing.py* \
       %{buildroot}%{_datadir}/hplip/check.py* \
       %{buildroot}%{_datadir}/hplip/devicesettings.py* \
       %{buildroot}%{_datadir}/hplip/diagnose_plugin.py* \
       %{buildroot}%{_datadir}/hplip/faxsetup.py* \
       %{buildroot}%{_datadir}/hplip/linefeedcal.py* \
       %{buildroot}%{_datadir}/hplip/makecopies.py* \
       %{buildroot}%{_datadir}/hplip/print.py* \
       %{buildroot}%{_datadir}/hplip/printsettings.py* \
       %{buildroot}%{_datadir}/hplip/systray.py* \
       %{buildroot}%{_datadir}/hplip/scan.py* \
       %{buildroot}%{_datadir}/hplip/toolbox.py* \
       %{buildroot}%{_datadir}/hplip/uiscan.py* \
       %{buildroot}%{_datadir}/hplip/wificonfig.py* \
       %{buildroot}%{_datadir}/hplip/data/images \
       %{buildroot}%{_datadir}/hplip/scan \
       %{buildroot}%{_datadir}/hplip/ui5 \
       %{buildroot}%{_docdir}/hplip/hpscan.html \
       doc/hpscan.html

install -p -m755 hp-plugin %{buildroot}%{_bindir}/hp-plugin-download
install -p -m755 %{SOURCE1} %{buildroot}%{_bindir}/hpcups-update-ppds
mkdir -p %{buildroot}%{_datadir}/hplip/prnt/plugins
mkdir -p %{buildroot}%{_sysconfdir}/sane.d/dll.d
echo hpaio > %{buildroot}%{_sysconfdir}/sane.d/dll.d/hpaio
find doc/images -type f -exec chmod 644 {} \;


%post
timeout 10m -k 15m %{_bindir}/hpcups-update-ppds &>/dev/null ||:

%files
%license COPYING
%doc doc/*
%{_bindir}/hpijs
%{_bindir}/hpcups-update-ppds
%{_bindir}/hp-align
%{_bindir}/hp-clean
%{_bindir}/hp-colorcal
%{_bindir}/hp-config_usb_printer
%{_bindir}/hp-diagnose_queues
%{_bindir}/hp-fab
%{_bindir}/hp-firmware
%{_bindir}/hp-info
%{_bindir}/hp-levels
%{_bindir}/hp-makeuri
%{_bindir}/hp-plugin
%{_bindir}/hp-plugin-download
%{_bindir}/hp-probe
%{_bindir}/hp-query
%{_bindir}/hp-sendfax
%{_bindir}/hp-setup
%{_bindir}/hp-testpage
%{_bindir}/hp-timedate
%{_cups_serverbin}/backend/hp
%{_cups_serverbin}/backend/hpfax
%{_cups_serverbin}/filter/hpcups
%{_cups_serverbin}/filter/hpcupsfax
%{_cups_serverbin}/filter/hpps
%{_cups_serverbin}/filter/pstotiff
%{_datadir}/cups/drv/*
%{_datadir}/cups/mime/pstotiff.convs
%{_datadir}/hplip/base
%{_datadir}/hplip/copier
%{_datadir}/hplip/data/ldl
%{_datadir}/hplip/data/localization
%{_datadir}/hplip/data/pcl
%{_datadir}/hplip/data/ps
%{_datadir}/hplip/installer
%{_datadir}/hplip/prnt
%{_datadir}/hplip/align.py*
%{_datadir}/hplip/check-plugin.py*
%{_datadir}/hplip/clean.py*
%{_datadir}/hplip/colorcal.py*
%{_datadir}/hplip/config_usb_printer.py*
%{_datadir}/hplip/diagnose_queues.py*
%{_datadir}/hplip/fab.py*
%{_datadir}/hplip/fax
%{_datadir}/hplip/firmware.py*
%{_datadir}/hplip/hpdio.py*
%{_datadir}/hplip/hplip_clean.sh
%{_datadir}/hplip/hpssd*
%{_datadir}/hplip/info.py*
%{_datadir}/hplip/__init__.py*
%{_datadir}/hplip/levels.py*
%{_datadir}/hplip/makeuri.py*
%{_datadir}/hplip/plugin.py*
%{_datadir}/hplip/probe.py*
%{_datadir}/hplip/query.py*
%{_datadir}/hplip/sendfax.py*
%{_datadir}/hplip/setup.py*
%{_datadir}/hplip/testpage.py*
%{_datadir}/hplip/timedate.py*
%{_datadir}/hplip/unload.py*
%{_datadir}/ppd
%{_sharedstatedir}/hp
%dir %attr(0775,root,lp) /run/hplip
%{_tmpfilesdir}/hplip.conf
%{_udevrulesdir}/56-hpmud.rules

%files common
%license COPYING
%dir %{_sysconfdir}/hp
%config(noreplace) %{_sysconfdir}/hp/hplip.conf
%dir %{_datadir}/hplip
%dir %{_datadir}/hplip/data
%{_datadir}/hplip/data/models

%files libs
%{_libdir}/libhpip.so.0
%{_libdir}/libhpip.so.0.0.1
%{_libdir}/libhpipp.so.0
%{_libdir}/libhpipp.so.0.0.1
%{_libdir}/libhpdiscovery.so.0
%{_libdir}/libhpdiscovery.so.0.0.1
%{_libdir}/libhpmud.so.0
%{_libdir}/libhpmud.so.0.0.6
%{python3_sitearch}/*

%files -n libsane-hpaio
%{_libdir}/sane/libsane-*.so
%{_libdir}/sane/libsane-*.so.1
%{_libdir}/sane/libsane-*.so.1.0.0
%config(noreplace) %{_sysconfdir}/sane.d/dll.d/hpaio


%changelog
* Thu Sep 26 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 3.22.10-6
- Rebuilt for clarifying the packages requirement in BaseOS and AppStream

* Fri Aug 16 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 3.22.10-5
- Rebuilt for loongarch release

* Tue Sep 19 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 3.22.10-4
- Rebuilt for python 3.11

* Fri Sep 08 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 3.22.10-3
- Rebuilt for OpenCloudOS Stream 23.09

* Fri Apr 28 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 3.22.10-2
- Rebuilt for OpenCloudOS Stream 23.05

* Fri Apr 07 2023 Miaojun Dong <zoedong@tencent.com> - 3.22.10-1
- initial build
